Index: drivers/filesystems/btrfs/btrfs_drv.h
===================================================================
--- drivers/filesystems/btrfs/btrfs_drv.h	(révision 75772)
+++ drivers/filesystems/btrfs/btrfs_drv.h	(copie de travail)
@@ -1,17 +1,17 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
@@ -22,11 +22,23 @@
 #undef _WIN32_WINNT
 #undef NTDDI_VERSION
 
-#define _WIN32_WINNT 0x0600
-#define NTDDI_VERSION 0x06010000 // Win 7
+#define _WIN32_WINNT 0x0601
+#define NTDDI_VERSION 0x06020000 // Win 8
 #define _CRT_SECURE_NO_WARNINGS
+#define _NO_CRT_STDIO_INLINE
 #endif /* __REACTOS__ */
 
+#ifdef _MSC_VER
+#pragma warning(push)
+#pragma warning(disable:4163)
+#pragma warning(disable:4311)
+#pragma warning(disable:4312)
+#else
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wsign-compare"
+#pragma GCC diagnostic ignored "-Wsign-conversion"
+#endif
+
 #include <ntifs.h>
 #include <ntddk.h>
 #ifdef __REACTOS__
@@ -38,9 +50,15 @@
 #include <iotypes.h>
 #include <pseh/pseh2.h>
 #endif /* __REACTOS__ */
-//#include <windows.h>
 #include <windef.h>
 #include <wdm.h>
+
+#ifdef _MSC_VER
+#pragma warning(pop)
+#else
+#pragma GCC diagnostic pop
+#endif
+
 #include <stdio.h>
 #include <stdarg.h>
 #include <stddef.h>
@@ -59,6 +77,8 @@
 #define DEBUG_PARANOID
 #endif
 
+#define UNUSED(x) (void)(x)
+
 #define BTRFS_NODE_TYPE_CCB 0x2295
 #define BTRFS_NODE_TYPE_FCB 0x2296
 
@@ -65,8 +85,6 @@
 #define ALLOC_TAG 0x7442484D //'MHBt'
 #define ALLOC_TAG_ZLIB 0x7A42484D //'MHBz'
 
-#define STDCALL __stdcall
-
 #define UID_NOBODY 65534
 #define GID_NOBODY 65534
 
@@ -76,12 +94,15 @@
 #define EA_DOSATTRIB "user.DOSATTRIB"
 #define EA_DOSATTRIB_HASH 0x914f9939
 
-#define EA_REPARSE "system.reparse"
-#define EA_REPARSE_HASH 0x786f6167
+#define EA_REPARSE "user.reparse"
+#define EA_REPARSE_HASH 0xfabad1fe
 
 #define EA_EA "user.EA"
 #define EA_EA_HASH 0x8270dd43
 
+#define EA_PROP_COMPRESSION "btrfs.compression"
+#define EA_PROP_COMPRESSION_HASH 0x20ccdf69
+
 #define MAX_EXTENT_SIZE 0x8000000 // 128 MB
 #define COMPRESSED_EXTENT_SIZE 0x20000 // 128 KB
 
@@ -89,6 +110,8 @@
 
 #define IO_REPARSE_TAG_LXSS_SYMLINK 0xa000001d // undocumented?
 
+#define BTRFS_VOLUME_PREFIX L"\\Device\\Btrfs{"
+
 #ifdef _MSC_VER
 #define try __try
 #define except __except
@@ -99,30 +122,63 @@
 #define finally if (1)
 #endif
 
-// #pragma pack(push, 1)
+#ifndef FILE_SUPPORTS_BLOCK_REFCOUNTING
+#define FILE_SUPPORTS_BLOCK_REFCOUNTING 0x08000000
+#endif
 
-struct _device_extension;
+#ifndef FILE_DEVICE_ALLOW_APPCONTAINER_TRAVERSAL
+#define FILE_DEVICE_ALLOW_APPCONTAINER_TRAVERSAL 0x00020000
+#endif
 
-typedef struct {
-    BTRFS_UUID fsuuid;
-    BTRFS_UUID devuuid;
-    UINT64 devnum;
-    UNICODE_STRING devpath;
-    UINT64 length;
-    UINT64 gen1, gen2;
-    BOOL seeding;
-    BOOL processed;
-    DWORD disk_num;
-    DWORD part_num;
-    LIST_ENTRY list_entry;
-} volume;
+typedef struct _DUPLICATE_EXTENTS_DATA {
+    HANDLE FileHandle;
+    LARGE_INTEGER SourceFileOffset;
+    LARGE_INTEGER TargetFileOffset;
+    LARGE_INTEGER ByteCount;
+} DUPLICATE_EXTENTS_DATA, *PDUPLICATE_EXTENTS_DATA;
 
-typedef struct {
-    UNICODE_STRING devpath;
-    ULONG disk_num;
-    LIST_ENTRY list_entry;
-} pnp_disk;
+#define FSCTL_DUPLICATE_EXTENTS_TO_FILE CTL_CODE(FILE_DEVICE_FILE_SYSTEM, 209, METHOD_BUFFERED, FILE_WRITE_ACCESS)
 
+typedef struct _FSCTL_GET_INTEGRITY_INFORMATION_BUFFER {
+    WORD ChecksumAlgorithm;
+    WORD Reserved;
+    DWORD Flags;
+    DWORD ChecksumChunkSizeInBytes;
+    DWORD ClusterSizeInBytes;
+} FSCTL_GET_INTEGRITY_INFORMATION_BUFFER, *PFSCTL_GET_INTEGRITY_INFORMATION_BUFFER;
+
+typedef struct _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER {
+    WORD ChecksumAlgorithm;
+    WORD Reserved;
+    DWORD Flags;
+} FSCTL_SET_INTEGRITY_INFORMATION_BUFFER, *PFSCTL_SET_INTEGRITY_INFORMATION_BUFFER;
+
+#define FSCTL_GET_INTEGRITY_INFORMATION CTL_CODE(FILE_DEVICE_FILE_SYSTEM, 159, METHOD_BUFFERED, FILE_ANY_ACCESS)
+#define FSCTL_SET_INTEGRITY_INFORMATION CTL_CODE(FILE_DEVICE_FILE_SYSTEM, 160, METHOD_BUFFERED, FILE_READ_DATA | FILE_WRITE_DATA)
+
+#ifndef __REACTOS__
+#ifndef _MSC_VER
+#define __drv_aliasesMem
+#define _Requires_lock_held_(a)
+#define _Requires_exclusive_lock_held_(a)
+#define _Releases_lock_(a)
+#define _Out_writes_bytes_opt_(a)
+#define _Pre_satisfies_(a)
+#define _Post_satisfies_(a)
+#define _Releases_exclusive_lock_(a)
+#define _Dispatch_type_(a)
+#define _Create_lock_level_(a)
+#define _Lock_level_order_(a,b)
+#define _Has_lock_level_(a)
+#endif
+#endif
+
+_Create_lock_level_(tree_lock)
+_Create_lock_level_(fcb_lock)
+_Lock_level_order_(tree_lock, fcb_lock)
+
+struct _device_extension;
+
 typedef struct _fcb_nonpaged {
     FAST_MUTEX HeaderMutex;
     SECTION_OBJECT_POINTERS segment_object;
@@ -135,14 +191,15 @@
 
 typedef struct {
     UINT64 offset;
-    EXTENT_DATA* data;
-    ULONG datalen;
+    UINT16 datalen;
     BOOL unique;
     BOOL ignore;
     BOOL inserted;
     UINT32* csum;
-    
+
     LIST_ENTRY list_entry;
+
+    EXTENT_DATA extent_data;
 } extent;
 
 typedef struct {
@@ -164,6 +221,7 @@
     UNICODE_STRING name;
     UINT32 hash_uc;
     UNICODE_STRING name_uc;
+    ULONG size;
     struct _file_ref* fileref;
     LIST_ENTRY list_entry_index;
     LIST_ENTRY list_entry_hash;
@@ -170,10 +228,25 @@
     LIST_ENTRY list_entry_hash_uc;
 } dir_child;
 
+enum prop_compression_type {
+    PropCompression_None,
+    PropCompression_Zlib,
+    PropCompression_LZO
+};
+
+typedef struct {
+    LIST_ENTRY list_entry;
+    USHORT namelen;
+    USHORT valuelen;
+    BOOL dirty;
+    char data[1];
+} xattr;
+
 typedef struct _fcb {
     FSRTL_ADVANCED_FCB_HEADER Header;
     struct _fcb_nonpaged* nonpaged;
     LONG refcount;
+    POOL_TYPE pool_type;
     struct _device_extension* Vcb;
     struct _root* subvol;
     UINT64 inode;
@@ -186,8 +259,8 @@
     ULONG atts;
     SHARE_ACCESS share_access;
     WCHAR* debug_desc;
+    BOOL csum_loaded;
     LIST_ENTRY extents;
-    UINT64 last_dir_index;
     ANSI_STRING reparse_xattr;
     ANSI_STRING ea_xattr;
     ULONG ealen;
@@ -194,47 +267,45 @@
     LIST_ENTRY hardlinks;
     struct _file_ref* fileref;
     BOOL inode_item_changed;
-    
+    enum prop_compression_type prop_compression;
+    LIST_ENTRY xattrs;
+
     LIST_ENTRY dir_children_index;
     LIST_ENTRY dir_children_hash;
     LIST_ENTRY dir_children_hash_uc;
     LIST_ENTRY** hash_ptrs;
     LIST_ENTRY** hash_ptrs_uc;
-    
+
     BOOL dirty;
-    BOOL sd_dirty;
+    BOOL sd_dirty, sd_deleted;
     BOOL atts_changed, atts_deleted;
     BOOL extents_changed;
     BOOL reparse_xattr_changed;
     BOOL ea_changed;
+    BOOL prop_compression_changed;
+    BOOL xattrs_changed;
     BOOL created;
-    
+
     BOOL ads;
     UINT32 adshash;
     ULONG adsmaxlen;
     ANSI_STRING adsxattr;
     ANSI_STRING adsdata;
-    
+
     LIST_ENTRY list_entry;
     LIST_ENTRY list_entry_all;
+    LIST_ENTRY list_entry_dirty;
 } fcb;
 
 typedef struct {
-    fcb* fcb;
-    LIST_ENTRY list_entry;
-} dirty_fcb;
-
-typedef struct {
+    ERESOURCE fileref_lock;
     ERESOURCE children_lock;
 } file_ref_nonpaged;
 
 typedef struct _file_ref {
     fcb* fcb;
-    UNICODE_STRING filepart;
-    UNICODE_STRING filepart_uc;
-    ANSI_STRING utf8;
     ANSI_STRING oldutf8;
-    UINT64 index;
+    UINT64 oldindex;
     BOOL delete_on_close;
     BOOL deleted;
     BOOL created;
@@ -245,16 +316,21 @@
     struct _file_ref* parent;
     WCHAR* debug_desc;
     dir_child* dc;
-    
+
     BOOL dirty;
-    
+
     LIST_ENTRY list_entry;
+    LIST_ENTRY list_entry_dirty;
 } file_ref;
 
 typedef struct {
-    file_ref* fileref;
+    HANDLE thread;
+    struct _ccb* ccb;
+    void* context;
+    KEVENT cleared_event;
+    BOOL cancelling;
     LIST_ENTRY list_entry;
-} dirty_fileref;
+} send_info;
 
 typedef struct _ccb {
     USHORT NodeType;
@@ -262,12 +338,12 @@
     ULONG disposition;
     ULONG options;
     UINT64 query_dir_offset;
-//     char* query_string;
     UNICODE_STRING query_string;
     BOOL has_wildcard;
     BOOL specific_file;
     BOOL manage_volume_privilege;
     BOOL allow_extended_dasd_io;
+    BOOL reserving;
     ACCESS_MASK access;
     file_ref* fileref;
     UNICODE_STRING filename;
@@ -277,36 +353,17 @@
     BOOL user_set_access_time;
     BOOL user_set_write_time;
     BOOL user_set_change_time;
+    BOOL lxss;
+    send_info* send;
+    NTSTATUS send_status;
 } ccb;
 
-// typedef struct _log_to_phys {
-//     UINT64 address;
-//     UINT64 size;
-//     UINT64 physaddr;
-//     UINT32 sector_size;
-//     struct _log_to_phys* next;
-// } log_to_phys;
-
 struct _device_extension;
 
-// enum tree_holder_status {
-//     tree_holder_unloaded,
-//     tree_holder_loading,
-//     tree_holder_loaded,
-//     tree_holder_unloading
-// };
-
-// typedef struct {
-//     enum tree_holder_status status;
-//     KSPIN_LOCK spin_lock;
-//     ERESOURCE lock;
-// } tree_holder_nonpaged;
-
 typedef struct {
     UINT64 address;
     UINT64 generation;
     struct _tree* tree;
-//     tree_holder_nonpaged* nonpaged;
 } tree_holder;
 
 typedef struct _tree_data {
@@ -314,24 +371,18 @@
     LIST_ENTRY list_entry;
     BOOL ignore;
     BOOL inserted;
-    
+
     union {
         tree_holder treeholder;
-        
+
         struct {
-            UINT32 size;
+            UINT16 size;
             UINT8* data;
         };
     };
 } tree_data;
 
-// typedef struct _tree_nonpaged {
-//     ERESOURCE load_tree_lock;
-// } tree_nonpaged;
-
 typedef struct _tree {
-//     UINT64 address;
-//     UINT8 level;
     tree_header header;
     UINT32 hash;
     BOOL has_address;
@@ -340,7 +391,6 @@
     struct _tree* parent;
     tree_data* paritem;
     struct _root* root;
-//     tree_nonpaged* nonpaged;
     LIST_ENTRY itemlist;
     LIST_ENTRY list_entry;
     LIST_ENTRY list_entry_hash;
@@ -348,10 +398,12 @@
     BOOL has_new_address;
     BOOL updated_extents;
     BOOL write;
+    BOOL is_unique;
+    BOOL uniqueness_determined;
+    UINT8* buf;
 } tree;
 
 typedef struct {
-//     KSPIN_LOCK load_tree_lock;
     ERESOURCE load_tree_lock;
 } root_nonpaged;
 
@@ -361,9 +413,14 @@
     tree_holder treeholder;
     root_nonpaged* nonpaged;
     ROOT_ITEM root_item;
-    UNICODE_STRING path;
+    BOOL dirty;
+    BOOL received;
+    PEPROCESS reserved;
+    UINT64 parent;
+    LONG send_ops;
     LIST_ENTRY fcbs;
     LIST_ENTRY list_entry;
+    LIST_ENTRY list_entry_dirty;
 } root;
 
 enum batch_operation {
@@ -377,6 +434,9 @@
     Batch_DeleteDirItem,
     Batch_DeleteInodeRef,
     Batch_DeleteInodeExtRef,
+    Batch_DeleteXattr,
+    Batch_DeleteExtentData,
+    Batch_DeleteFreeSpace,
 };
 
 typedef struct {
@@ -417,14 +477,17 @@
     BOOL seeding;
     BOOL readonly;
     BOOL reloc;
-    BOOL ssd;
     BOOL trim;
+    BOOL can_flush;
     ULONG change_count;
-    UINT64 length;
     ULONG disk_num;
     ULONG part_num;
+    UINT64 stats[5];
+    BOOL stats_changed;
     LIST_ENTRY space;
     LIST_ENTRY list_entry;
+    ULONG num_trim_entries;
+    LIST_ENTRY trim_list;
 } device;
 
 typedef struct {
@@ -435,19 +498,28 @@
 } range_lock;
 
 typedef struct {
+    UINT64 address;
+    ULONG* bmparr;
+    RTL_BITMAP bmp;
+    LIST_ENTRY list_entry;
+    UINT8 data[1];
+} partial_stripe;
+
+typedef struct {
     CHUNK_ITEM* chunk_item;
-    UINT32 size;
+    UINT16 size;
     UINT64 offset;
     UINT64 used;
-    UINT32 oldused;
+    UINT64 oldused;
     device** devices;
     fcb* cache;
+    fcb* old_cache;
     LIST_ENTRY space;
     LIST_ENTRY space_size;
     LIST_ENTRY deleting;
     LIST_ENTRY changed_extents;
     LIST_ENTRY range_locks;
-    KSPIN_LOCK range_locks_spinlock;
+    ERESOURCE range_locks_lock;
     KEVENT range_locks_event;
     ERESOURCE lock;
     ERESOURCE changed_extents_lock;
@@ -455,10 +527,16 @@
     BOOL readonly;
     BOOL reloc;
     BOOL last_alloc_set;
+    BOOL cache_loaded;
+    BOOL changed;
+    BOOL space_changed;
     UINT64 last_alloc;
-    
+    UINT16 last_stripe;
+    LIST_ENTRY partial_stripes;
+    ERESOURCE partial_stripes_lock;
+    ULONG balance_num;
+
     LIST_ENTRY list_entry;
-    LIST_ENTRY list_entry_changed;
     LIST_ENTRY list_entry_balance;
 } chunk;
 
@@ -477,12 +555,12 @@
 
 typedef struct {
     UINT8 type;
-    
+
     union {
         EXTENT_DATA_REF edr;
         SHARED_DATA_REF sdr;
     };
-    
+
     LIST_ENTRY list_entry;
 } changed_extent_ref;
 
@@ -528,14 +606,17 @@
     UINT32 flush_interval;
     UINT32 max_inline;
     UINT64 subvol_id;
-    UINT32 raid5_recalculation;
-    UINT32 raid6_recalculation;
     BOOL skip_balance;
+    BOOL no_barrier;
+    BOOL no_trim;
+    BOOL clear_cache;
+    BOOL allow_degraded;
 } mount_options;
 
-#define VCB_TYPE_VOLUME     1
-#define VCB_TYPE_PARTITION0 2
-#define VCB_TYPE_CONTROL    3
+#define VCB_TYPE_FS         1
+#define VCB_TYPE_CONTROL    2
+#define VCB_TYPE_VOLUME     3
+#define VCB_TYPE_PDO        4
 
 #ifdef DEBUG_STATS
 typedef struct {
@@ -544,7 +625,7 @@
     UINT64 read_total_time;
     UINT64 read_csum_time;
     UINT64 read_disk_time;
-    
+
     UINT64 num_opens;
     UINT64 open_total_time;
     UINT64 num_overwrites;
@@ -551,6 +632,8 @@
     UINT64 overwrite_total_time;
     UINT64 num_creates;
     UINT64 create_total_time;
+    UINT64 open_fcb_calls;
+    UINT64 open_fcb_time;
 } debug_stats;
 #endif
 
@@ -565,26 +648,71 @@
     btrfs_balance_opts opts[3];
     BOOL paused;
     BOOL stopping;
-    BOOL cancelling;
     BOOL removing;
+    BOOL shrinking;
     BOOL dev_readonly;
+    ULONG balance_num;
     NTSTATUS status;
     KEVENT event;
     KEVENT finished;
 } balance_info;
 
+typedef struct {
+    UINT64 address;
+    UINT64 device;
+    BOOL recovered;
+    BOOL is_metadata;
+    BOOL parity;
+    LIST_ENTRY list_entry;
+
+    union {
+        struct {
+            UINT64 subvol;
+            UINT64 offset;
+            UINT16 filename_length;
+            WCHAR filename[1];
+        } data;
+
+        struct {
+            UINT64 root;
+            UINT8 level;
+            KEY firstitem;
+        } metadata;
+    };
+} scrub_error;
+
+typedef struct {
+    HANDLE thread;
+    ERESOURCE stats_lock;
+    KEVENT event;
+    KEVENT finished;
+    BOOL stopping;
+    BOOL paused;
+    LARGE_INTEGER start_time;
+    LARGE_INTEGER finish_time;
+    LARGE_INTEGER resume_time;
+    LARGE_INTEGER duration;
+    UINT64 total_chunks;
+    UINT64 chunks_left;
+    UINT64 data_scrubbed;
+    NTSTATUS error;
+    ULONG num_errors;
+    LIST_ENTRY errors;
+} scrub_info;
+
+struct _volume_device_extension;
+
 typedef struct _device_extension {
     UINT32 type;
     mount_options options;
     PVPB Vpb;
+    struct _volume_device_extension* vde;
     LIST_ENTRY devices;
 #ifdef DEBUG_STATS
     debug_stats stats;
 #endif
     UINT64 devices_loaded;
-//     DISK_GEOMETRY geometry;
     superblock superblock;
-//     WCHAR label[MAX_LABEL_SIZE];
     BOOL readonly;
     BOOL removing;
     BOOL locked;
@@ -593,21 +721,19 @@
     BOOL trim;
     PFILE_OBJECT locked_fileobj;
     fcb* volume_fcb;
+    fcb* dummy_fcb;
     file_ref* root_fileref;
     LONG open_files;
-    ERESOURCE fcb_lock;
+    _Has_lock_level_(fcb_lock) ERESOURCE fcb_lock;
     ERESOURCE load_lock;
-    ERESOURCE tree_lock;
+    _Has_lock_level_(tree_lock) ERESOURCE tree_lock;
     PNOTIFY_SYNC NotifySync;
     LIST_ENTRY DirNotifyList;
-    LONG open_trees;
     BOOL need_write;
-//     ERESOURCE LogToPhysLock;
-//     UINT64 chunk_root_phys_addr;
+    BOOL stats_changed;
     UINT64 data_flags;
     UINT64 metadata_flags;
     UINT64 system_flags;
-//     log_to_phys* log_to_phys;
     LIST_ENTRY roots;
     LIST_ENTRY drop_roots;
     root* chunk_root;
@@ -617,18 +743,21 @@
     root* dev_root;
     root* uuid_root;
     root* data_reloc_root;
+    root* space_root;
     BOOL log_to_phys_loaded;
+    BOOL chunk_usage_found;
     LIST_ENTRY sys_chunks;
     LIST_ENTRY chunks;
-    LIST_ENTRY chunks_changed;
     LIST_ENTRY trees;
     LIST_ENTRY trees_hash;
     LIST_ENTRY* trees_ptrs[256];
     LIST_ENTRY all_fcbs;
     LIST_ENTRY dirty_fcbs;
-    KSPIN_LOCK dirty_fcbs_lock;
+    ERESOURCE dirty_fcbs_lock;
     LIST_ENTRY dirty_filerefs;
-    KSPIN_LOCK dirty_filerefs_lock;
+    ERESOURCE dirty_filerefs_lock;
+    LIST_ENTRY dirty_subvols;
+    ERESOURCE dirty_subvols_lock;
     ERESOURCE chunk_lock;
     HANDLE flush_thread_handle;
     KTIMER flush_thread_timer;
@@ -635,26 +764,76 @@
     KEVENT flush_thread_finished;
     drv_calc_threads calcthreads;
     balance_info balance;
+    scrub_info scrub;
+    ERESOURCE send_load_lock;
+    LONG running_sends;
+    LIST_ENTRY send_ops;
     PFILE_OBJECT root_file;
     PAGED_LOOKASIDE_LIST tree_data_lookaside;
     PAGED_LOOKASIDE_LIST traverse_ptr_lookaside;
-    PAGED_LOOKASIDE_LIST rollback_item_lookaside;
     PAGED_LOOKASIDE_LIST batch_item_lookaside;
+    PAGED_LOOKASIDE_LIST fileref_lookaside;
+    PAGED_LOOKASIDE_LIST fcb_lookaside;
+    PAGED_LOOKASIDE_LIST name_bit_lookaside;
     NPAGED_LOOKASIDE_LIST range_lock_lookaside;
+    NPAGED_LOOKASIDE_LIST fileref_np_lookaside;
+    NPAGED_LOOKASIDE_LIST fcb_np_lookaside;
     LIST_ENTRY list_entry;
 } device_extension;
 
 typedef struct {
     UINT32 type;
+    PDEVICE_OBJECT buspdo;
+    PDEVICE_OBJECT attached_device;
+    UNICODE_STRING bus_name;
+} control_device_extension;
+
+typedef struct {
+    BTRFS_UUID uuid;
+    UINT64 devid;
+    UINT64 generation;
     PDEVICE_OBJECT devobj;
-    BTRFS_UUID uuid;
+    PFILE_OBJECT fileobj;
+    UNICODE_STRING pnp_name;
+    UINT64 size;
+    BOOL seeding;
+    BOOL had_drive_letter;
+    void* notification_entry;
+    ULONG disk_num;
+    ULONG part_num;
+    LIST_ENTRY list_entry;
+} volume_child;
+
+struct pdo_device_extension;
+
+typedef struct _volume_device_extension {
+    UINT32 type;
     UNICODE_STRING name;
-} part0_device_extension;
+    PDEVICE_OBJECT device;
+    PDEVICE_OBJECT mounted_device;
+    PDEVICE_OBJECT pdo;
+    struct pdo_device_extension* pdode;
+    UNICODE_STRING bus_name;
+    PDEVICE_OBJECT attached_device;
+    BOOL removing;
+    LONG open_count;
+} volume_device_extension;
 
-typedef struct {
+typedef struct pdo_device_extension {
     UINT32 type;
-} control_device_extension;
+    BTRFS_UUID uuid;
+    volume_device_extension* vde;
+    PDEVICE_OBJECT pdo;
+    BOOL removable;
 
+    UINT64 num_children;
+    UINT64 children_loaded;
+    ERESOURCE child_lock;
+    LIST_ENTRY children;
+
+    LIST_ENTRY list_entry;
+} pdo_device_extension;
+
 typedef struct {
     LIST_ENTRY listentry;
     PSID sid;
@@ -661,6 +840,12 @@
     UINT32 uid;
 } uid_map;
 
+typedef struct {
+    LIST_ENTRY listentry;
+    PSID sid;
+    UINT32 gid;
+} gid_map;
+
 enum write_data_status {
     WriteDataStatus_Pending,
     WriteDataStatus_Success,
@@ -675,7 +860,7 @@
 typedef struct {
     struct _write_data_context* context;
     UINT8* buf;
-    BOOL need_free;
+    PMDL mdl;
     device* device;
     PIRP Irp;
     IO_STATUS_BLOCK iosb;
@@ -687,24 +872,29 @@
     KEVENT Event;
     LIST_ENTRY stripes;
     LONG stripes_left;
-    BOOL tree;
+    BOOL need_wait;
+    UINT8 *parity1, *parity2, *scratch;
+    PMDL mdl, parity1_mdl, parity2_mdl;
 } write_data_context;
 
 typedef struct {
     UINT64 address;
     UINT32 length;
-    BOOL overlap;
     UINT8* data;
+    chunk* c;
     LIST_ENTRY list_entry;
 } tree_write;
 
-// #pragma pack(pop)
+typedef struct {
+    UNICODE_STRING us;
+    LIST_ENTRY list_entry;
+} name_bit;
 
-static __inline void* map_user_buffer(PIRP Irp) {
+static __inline void* map_user_buffer(PIRP Irp, ULONG priority) {
     if (!Irp->MdlAddress) {
         return Irp->UserBuffer;
     } else {
-        return MmGetSystemAddressForMdlSafe(Irp->MdlAddress, NormalPagePriority);
+        return MmGetSystemAddressForMdlSafe(Irp->MdlAddress, priority);
     }
 }
 
@@ -714,17 +904,18 @@
 
 static __inline void win_time_to_unix(LARGE_INTEGER t, BTRFS_TIME* out) {
     ULONGLONG l = t.QuadPart - 116444736000000000;
-    
+
     out->seconds = l / 10000000;
     out->nanoseconds = (l % 10000000) * 100;
 }
 
-static __inline void get_raid0_offset(UINT64 off, UINT64 stripe_length, UINT16 num_stripes, UINT64* stripeoff, UINT16* stripe) {
+_Post_satisfies_(*stripe>=0&&*stripe<num_stripes)
+static __inline void get_raid0_offset(_In_ UINT64 off, _In_ UINT64 stripe_length, _In_ UINT16 num_stripes, _Out_ UINT64* stripeoff, _Out_ UINT16* stripe) {
     UINT64 initoff, startoff;
-    
+
     startoff = off % (num_stripes * stripe_length);
     initoff = (off / (num_stripes * stripe_length)) * stripe_length;
-    
+
     *stripe = (UINT16)(startoff / stripe_length);
     *stripeoff = initoff + startoff - (*stripe * stripe_length);
 }
@@ -734,11 +925,7 @@
  * five for the inode, which should be good enough.
  * Inodes are also 64 bits on Linux, but the Linux driver seems to get round
  * this by tricking it into thinking subvols are separate volumes. */
-#ifdef __REACTOS__
 static __inline UINT64 make_file_id(root* r, UINT64 inode) {
-#else
-static UINT64 __inline make_file_id(root* r, UINT64 inode) {
-#endif
     return (r->id << 40) | (inode & 0xffffffffff);
 }
 
@@ -751,39 +938,127 @@
     ((key1.offset > key2.offset) ? 1 :\
     0))))))
 
+_Post_satisfies_(return>=n)
+__inline static UINT64 sector_align(_In_ UINT64 n, _In_ UINT64 a) {
+    if (n & (a - 1))
+        n = (n + a) & ~(a - 1);
+
+    return n;
+}
+
+__inline static BOOL is_subvol_readonly(root* r, PIRP Irp) {
+    if (!(r->root_item.flags & BTRFS_SUBVOL_READONLY))
+        return FALSE;
+
+    if (!r->reserved)
+        return TRUE;
+
+    return (!Irp || Irp->RequestorMode == UserMode) && PsGetCurrentProcess() != r->reserved ? TRUE : FALSE;
+}
+
+__inline static UINT16 get_extent_data_len(UINT8 type) {
+    switch (type) {
+        case TYPE_TREE_BLOCK_REF:
+            return sizeof(TREE_BLOCK_REF);
+
+        case TYPE_EXTENT_DATA_REF:
+            return sizeof(EXTENT_DATA_REF);
+
+        case TYPE_EXTENT_REF_V0:
+            return sizeof(EXTENT_REF_V0);
+
+        case TYPE_SHARED_BLOCK_REF:
+            return sizeof(SHARED_BLOCK_REF);
+
+        case TYPE_SHARED_DATA_REF:
+            return sizeof(SHARED_DATA_REF);
+
+        default:
+            return 0;
+    }
+}
+
+__inline static UINT32 get_extent_data_refcount(UINT8 type, void* data) {
+    switch (type) {
+        case TYPE_TREE_BLOCK_REF:
+            return 1;
+
+        case TYPE_EXTENT_DATA_REF:
+        {
+            EXTENT_DATA_REF* edr = (EXTENT_DATA_REF*)data;
+            return edr->count;
+        }
+
+        case TYPE_EXTENT_REF_V0:
+        {
+            EXTENT_REF_V0* erv0 = (EXTENT_REF_V0*)data;
+            return erv0->count;
+        }
+
+        case TYPE_SHARED_BLOCK_REF:
+            return 1;
+
+        case TYPE_SHARED_DATA_REF:
+        {
+            SHARED_DATA_REF* sdr = (SHARED_DATA_REF*)data;
+            return sdr->count;
+        }
+
+        default:
+            return 0;
+    }
+}
+
 // in btrfs.c
-device* find_device_from_uuid(device_extension* Vcb, BTRFS_UUID* uuid);
-UINT64 sector_align( UINT64 NumberToBeAligned, UINT64 Alignment );
-BOOL get_file_attributes_from_xattr(char* val, UINT16 len, ULONG* atts);
-ULONG STDCALL get_file_attributes(device_extension* Vcb, INODE_ITEM* ii, root* r, UINT64 inode, UINT8 type, BOOL dotfile, BOOL ignore_xa, PIRP Irp);
-BOOL extract_xattr(void* item, USHORT size, char* name, UINT8** data, UINT16* datalen);
-BOOL STDCALL get_xattr(device_extension* Vcb, root* subvol, UINT64 inode, char* name, UINT32 crc32, UINT8** data, UINT16* datalen, PIRP Irp);
-void _free_fcb(fcb* fcb, const char* func, const char* file, unsigned int line);
-void _free_fileref(file_ref* fr, const char* func, const char* file, unsigned int line);
-fcb* create_fcb(POOL_TYPE pool_type);
-file_ref* create_fileref();
-void protect_superblocks(device_extension* Vcb, chunk* c);
-BOOL is_top_level(PIRP Irp);
-NTSTATUS create_root(device_extension* Vcb, UINT64 id, root** rootptr, BOOL no_tree, UINT64 offset, PIRP Irp, LIST_ENTRY* rollback);
-void STDCALL uninit(device_extension* Vcb, BOOL flush);
-NTSTATUS STDCALL dev_ioctl(PDEVICE_OBJECT DeviceObject, ULONG ControlCode, PVOID InputBuffer,
-                           ULONG InputBufferSize, PVOID OutputBuffer, ULONG OutputBufferSize, BOOLEAN Override, IO_STATUS_BLOCK* iosb);
-BOOL is_file_name_valid(PUNICODE_STRING us);
-void send_notification_fileref(file_ref* fileref, ULONG filter_match, ULONG action);
-void send_notification_fcb(file_ref* fileref, ULONG filter_match, ULONG action);
-WCHAR* file_desc(PFILE_OBJECT FileObject);
-WCHAR* file_desc_fileref(file_ref* fileref);
-BOOL add_thread_job(device_extension* Vcb, PIRP Irp);
-NTSTATUS part0_passthrough(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
-void mark_fcb_dirty(fcb* fcb);
-void mark_fileref_dirty(file_ref* fileref);
-NTSTATUS delete_fileref(file_ref* fileref, PFILE_OBJECT FileObject, PIRP Irp, LIST_ENTRY* rollback);
-void chunk_lock_range(device_extension* Vcb, chunk* c, UINT64 start, UINT64 length);
-void chunk_unlock_range(device_extension* Vcb, chunk* c, UINT64 start, UINT64 length);
-void init_device(device_extension* Vcb, device* dev, BOOL get_length, BOOL get_nums);
-void init_file_cache(PFILE_OBJECT FileObject, CC_FILE_SIZES* ccfs);
-NTSTATUS sync_read_phys(PDEVICE_OBJECT DeviceObject, LONGLONG StartingOffset, ULONG Length, PUCHAR Buffer, BOOL override);
+_Ret_maybenull_
+device* find_device_from_uuid(_In_ device_extension* Vcb, _In_ BTRFS_UUID* uuid);
 
+_Success_(return)
+BOOL get_file_attributes_from_xattr(_In_reads_bytes_(len) char* val, _In_ UINT16 len, _Out_ ULONG* atts);
+
+ULONG get_file_attributes(_In_ _Requires_lock_held_(_Curr_->tree_lock) device_extension* Vcb, _In_ root* r, _In_ UINT64 inode,
+                          _In_ UINT8 type, _In_ BOOL dotfile, _In_ BOOL ignore_xa, _In_opt_ PIRP Irp);
+
+_Success_(return)
+BOOL get_xattr(_In_ _Requires_lock_held_(_Curr_->tree_lock) device_extension* Vcb, _In_ root* subvol, _In_ UINT64 inode, _In_z_ char* name, _In_ UINT32 crc32,
+               _Out_ UINT8** data, _Out_ UINT16* datalen, _In_opt_ PIRP Irp);
+
+#ifndef DEBUG_FCB_REFCOUNTS
+void free_fcb(_Requires_exclusive_lock_held_(_Curr_->fcb_lock) _In_ device_extension* Vcb, _Inout_ fcb* fcb);
+#endif
+void free_fileref(_Requires_exclusive_lock_held_(_Curr_->fcb_lock) _In_ device_extension* Vcb, _Inout_ file_ref* fr);
+void protect_superblocks(_Inout_ chunk* c);
+BOOL is_top_level(_In_ PIRP Irp);
+NTSTATUS create_root(_In_ _Requires_exclusive_lock_held_(_Curr_->tree_lock) device_extension* Vcb, _In_ UINT64 id,
+                     _Out_ root** rootptr, _In_ BOOL no_tree, _In_ UINT64 offset, _In_opt_ PIRP Irp);
+void uninit(_In_ device_extension* Vcb, _In_ BOOL flush);
+NTSTATUS dev_ioctl(_In_ PDEVICE_OBJECT DeviceObject, _In_ ULONG ControlCode, _In_reads_bytes_opt_(InputBufferSize) PVOID InputBuffer, _In_ ULONG InputBufferSize,
+                   _Out_writes_bytes_opt_(OutputBufferSize) PVOID OutputBuffer, _In_ ULONG OutputBufferSize, _In_ BOOLEAN Override, _Out_opt_ IO_STATUS_BLOCK* iosb);
+BOOL is_file_name_valid(_In_ PUNICODE_STRING us, _In_ BOOL posix);
+void send_notification_fileref(_In_ file_ref* fileref, _In_ ULONG filter_match, _In_ ULONG action, _In_opt_ PUNICODE_STRING stream);
+void send_notification_fcb(_In_ file_ref* fileref, _In_ ULONG filter_match, _In_ ULONG action, _In_opt_ PUNICODE_STRING stream);
+
+_Ret_z_
+WCHAR* file_desc(_In_ PFILE_OBJECT FileObject);
+WCHAR* file_desc_fileref(_In_ file_ref* fileref);
+void mark_fcb_dirty(_In_ fcb* fcb);
+void mark_fileref_dirty(_In_ file_ref* fileref);
+NTSTATUS delete_fileref(_In_ file_ref* fileref, _In_ PFILE_OBJECT FileObject, _In_opt_ PIRP Irp, _In_ LIST_ENTRY* rollback);
+void chunk_lock_range(_In_ device_extension* Vcb, _In_ chunk* c, _In_ UINT64 start, _In_ UINT64 length);
+void chunk_unlock_range(_In_ device_extension* Vcb, _In_ chunk* c, _In_ UINT64 start, _In_ UINT64 length);
+void init_device(_In_ device_extension* Vcb, _Inout_ device* dev, _In_ BOOL get_nums);
+void init_file_cache(_In_ PFILE_OBJECT FileObject, _In_ CC_FILE_SIZES* ccfs);
+NTSTATUS sync_read_phys(_In_ PDEVICE_OBJECT DeviceObject, _In_ UINT64 StartingOffset, _In_ ULONG Length,
+                        _Out_writes_bytes_(Length) PUCHAR Buffer, _In_ BOOL override);
+NTSTATUS get_device_pnp_name(_In_ PDEVICE_OBJECT DeviceObject, _Out_ PUNICODE_STRING pnp_name, _Out_ const GUID** guid);
+void log_device_error(_In_ device_extension* Vcb, _Inout_ device* dev, _In_ int error);
+NTSTATUS find_chunk_usage(_In_ _Requires_lock_held_(_Curr_->tree_lock) device_extension* Vcb, _In_opt_ PIRP Irp);
+#ifdef __REACTOS__
+NTSTATUS NTAPI AddDevice(PDRIVER_OBJECT DriverObject, PDEVICE_OBJECT PhysicalDeviceObject);
+#else
+NTSTATUS AddDevice(PDRIVER_OBJECT DriverObject, PDEVICE_OBJECT PhysicalDeviceObject);
+#endif
+
 #ifdef _MSC_VER
 #define funcname __FUNCTION__
 #else
@@ -790,10 +1065,6 @@
 #define funcname __func__
 #endif
 
-// FIXME - we probably shouldn't be moving funcname etc. around if we're not printing debug messages
-#define free_fcb(fcb) _free_fcb(fcb, funcname, __FILE__, __LINE__)
-#define free_fileref(fileref) _free_fileref(fileref, funcname, __FILE__, __LINE__)
-
 extern BOOL have_sse2;
 
 extern UINT32 mount_compress;
@@ -802,9 +1073,13 @@
 extern UINT32 mount_zlib_level;
 extern UINT32 mount_flush_interval;
 extern UINT32 mount_max_inline;
-extern UINT32 mount_raid5_recalculation;
-extern UINT32 mount_raid6_recalculation;
 extern UINT32 mount_skip_balance;
+extern UINT32 mount_no_barrier;
+extern UINT32 mount_no_trim;
+extern UINT32 mount_clear_cache;
+extern UINT32 mount_allow_degraded;
+extern UINT32 mount_readonly;
+extern UINT32 no_pnp;
 
 #ifdef _DEBUG
 
@@ -820,7 +1095,7 @@
 #define FIXME(s, ...) MSG(funcname, __FILE__, __LINE__, s, 1, ##__VA_ARGS__)
 #define ERR(s, ...) MSG(funcname, __FILE__, __LINE__, s, 1, ##__VA_ARGS__)
 
-void STDCALL _debug_message(const char* func, const char* file, unsigned int line, char* s, ...);
+void _debug_message(_In_ const char* func, _In_ const char* file, _In_ unsigned int line, _In_ char* s, ...);
 
 #else
 
@@ -831,7 +1106,7 @@
 #define FIXME(s, ...) MSG(funcname, s, 1, ##__VA_ARGS__)
 #define ERR(s, ...) MSG(funcname, s, 1, ##__VA_ARGS__)
 
-void STDCALL _debug_message(const char* func, char* s, ...);
+void _debug_message(_In_ const char* func, _In_ char* s, ...);
 
 #endif
 
